package dev.inmo.postssystem.features.auth.client

import dev.inmo.postssystem.features.common.common.AdditionalModules
import dev.inmo.postssystem.features.common.common.ModuleLoader
import org.koin.core.module.Module

private val AuthorizedAdditionalModules = AdditionalModules()
val AdditionalModules.Companion.Authorized: AdditionalModules
    get() = AuthorizedAdditionalModules

fun AuthorizedModuleLoader(loadingBlock: Module.() -> Unit): ModuleLoader.ByCallback {
    val newModuleLoader = ModuleLoader.ByCallback(loadingBlock)
    AdditionalModules.Authorized.addModule(newModuleLoader)
    return newModuleLoader
}
