package dev.inmo.postssystem.services.posts.client

import dev.inmo.postssystem.features.auth.client.AuthorizedModuleLoader
import dev.inmo.postssystem.features.auth.client.AuthorizedQualifiers
import dev.inmo.postssystem.features.common.common.ui.fsm.UIFSMStateSerializer
import dev.inmo.postssystem.services.posts.client.ui.create.*
import dev.inmo.postssystem.services.posts.client.ui.list.PostsListUIFSMState
import dev.inmo.postssystem.services.posts.common.*
import org.koin.dsl.binds

val loader = AuthorizedModuleLoader {
    single<PostsService> { ClientPostsService(get(AuthorizedQualifiers.ServerUrlQualifier), get()) } binds arrayOf(
        ReadPostsService::class,
        WritePostsService::class
    )

    factory<PostCreateUIModel> { DefaultPostCreateUIModel(get(), get()) }
    factory { PostCreateUIViewModel(get()) }
}
