package dev.inmo.postssystem.targets.telegram.loader.client

import dev.inmo.postssystem.features.common.common.*
import dev.inmo.postssystem.features.content.common.ContentSerializersModuleConfigurator
import dev.inmo.postssystem.targets.telegram.content.polls.common.PollContent
import org.koin.core.module.Module

val defaultTelegramTargetModuleLoader = TelegramTargetModuleLoader

object TelegramTargetModuleLoader : ModuleLoader {
    init {
        AdditionalModules.Default.addModule(this)
    }

    override fun Module.load() {
        singleWithRandomQualifier<ContentSerializersModuleConfigurator.Element> {
            ContentSerializersModuleConfigurator.Element {
                subclass(PollContent::class, PollContent.serializer())
            }
        }
    }
}
